﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="Default.aspx.cs" Inherits="ReverseURL._Default" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<script runat="server">
    
    private void FindReverseUrl(Object sender, EventArgs e) {
        //Added basic error checking so the application does not blow up, fix later to handle specific errors.
        try {

            string inUrl = shortUrl.Text;
            if (!inUrl.Contains("http://")) {
                inUrl = "http://" + inUrl;
            }
            
            System.Net.HttpWebRequest request = (System.Net.HttpWebRequest)System.Net.HttpWebRequest.Create(inUrl);
            System.Net.HttpWebResponse response = (System.Net.HttpWebResponse)request.GetResponse();

            Uri uri = response.ResponseUri;
            
            StringBuilder urlText = new StringBuilder();
            urlText.Append("<span class=\"orange\">");
            urlText.Append(inUrl);
            urlText.Append("</span>");
            urlText.Append(" points to <strong><a href=\"");
            urlText.Append(uri.AbsoluteUri);
            urlText.Append("\">");
            urlText.Append(uri.AbsoluteUri);
            urlText.Append("</a></strong>");
            
            reversedUrl.Text = urlText.ToString();
            
        } catch (Exception ex) {
            reversedUrl.Text = "Error: could not reverse URL at this time, please try again later.";
        }
    }
</script>


<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title>Where does this link go? An online URL expander.</title>
    <link href="style.css" rel="stylesheet" type="text/css" />
    <script type="text/javascript">
        var _gaq = _gaq || [];
        _gaq.push(['_setAccount', 'UA-10287519-6']);
        _gaq.push(['_trackPageview']);

        (function () {
            var ga = document.createElement('script'); ga.type = 'text/javascript'; ga.async = true;
            ga.src = ('https:' == document.location.protocol ? 'https://ssl' : 'http://www') + '.google-analytics.com/ga.js';
            var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(ga, s);
        })();
    </script>
</head>
<body>

    <div id="container">
        <form id="formShortUrl" runat="server" action="" OnSubmit="FindReverseUrl">
            Where does <asp:TextBox ID="shortUrl" runat="server" Text='<%# Bind("URL") %>' /> go?
            <asp:Button id="id" text="Reverse URL" OnClick="FindReverseUrl" runat="server" style="display: none;" />
        </form>

        <p><asp:Label id="reversedUrl" runat="server" /></p>
    </div>

    <div id="footer">
        Created by <a href="http://creatingcode.com">Robert Greiner</a>.<br />
        Source code available at <a href="http://github.com/robertgreiner/ReverseURL">Github</a>.
    </div>
    
</body>
</html>
